package bb;

import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.rmi.server.UnicastRemoteObject;

import remoteInterfaces.BulletinBoard;

/**
 * The class responsible for binding the BulletinBoard to the RMI registry
 * 
 * @author bent
 * 
 */
public class RemoteEntityConnectionBB {

	private Registry registry;

	/**
	 * Starts a connection to the RMI registry at the given host and port.
	 * 
	 * @param host
	 * @param port
	 * @throws RemoteException
	 *             Thrown if the registry was not found
	 */
	public RemoteEntityConnectionBB(String host, int port)
			throws RemoteException {
		if (System.getSecurityManager() == null) {
			System.setSecurityManager(new SecurityManager());
		}
		try {
			registry = LocateRegistry.getRegistry(host, port);

		} catch (RemoteException e) {
			throw e;
		}
	}

	/**
	 * Binds the BulletinBoard to the RMI Registry
	 * 
	 * @return The stub for the remote BulletinBoard
	 * @throws RemoteException
	 *             If the binding of the BulletinBoard failed
	 */
	public BulletinBoard bindBulletinBoard() throws RemoteException {
		BulletinBoard stub = null;
		BulletinBoard_Impl bbi = new BulletinBoard_Impl();

		stub = (BulletinBoard) UnicastRemoteObject.exportObject(bbi, 0);
		registry.rebind("BulletinBoard", stub);
		System.out.println("BulletinBoard bound in registry");
		return stub;
	}
}
