package ea;

import java.rmi.RemoteException;

import remoteInterfaces.ElectionServer;
import votingSystem.ElectionProperties;
import votingSystem.KeyShare;
import votingSystem.PublicKey;
/** The implementation of the remote object ElectionServer holding the PublicKey, the KeyShares and the ElectionProperties of the election
 * 
 * @author bent
 *
 */
public class ElectionServer_Impl implements ElectionServer {

	private static ElectionProperties ep;

	private static ElectionServer_Impl esi;

	private static PublicKey pk;

	private static KeyShare[] ks;

	private int dsCounter = 0;

	private int voterCounter = 0;

	private int decryptionServerCounter = 0;
/** Constructor for the ElectionServer
 * 
 * @param eps The ElectionProperties for the election
 * @param pks The PublicKey for the election
 * @param kss The array of KeyShares for the decryption servers
 * @throws RemoteException
 */
	public ElectionServer_Impl(ElectionProperties eps, PublicKey pks,
			KeyShare[] kss) throws RemoteException {
		ep = eps;
		pk = pks;
		ks = kss;
	}
/** Assigns an id to the decryption server, and returns the KeyShare
 * 
 */
	public KeyShare getKeyShare() throws RemoteException {
		KeyShare temp = ks[dsCounter];
		dsCounter++;
		return temp;
	}

	public ElectionProperties getElectionProperties() throws RemoteException {
		return ep;
	}

	public PublicKey getPublicKey() throws RemoteException {
		return pk;
	}
/** Gives an id to a voter
 * 
 * @return The id
 */
	public int getVoterId() throws RemoteException {
		int temp = voterCounter;
		voterCounter++;
		if (temp < ep.getM()) {
			return temp;
		} else {
			return -1;
		}

	}

	public int getNoOfVoters() throws RemoteException {
		return voterCounter;
	}

	public int getNoOfDecryptionServers() throws RemoteException {
		return dsCounter;
	}

}
