package ea;

import java.math.BigInteger;
import java.security.SecureRandom;
import java.util.Random;

import voter.Voter;
import votingSystem.BinaryVote;
import votingSystem.DecryptedShare;
import votingSystem.ElectionProperties;
import votingSystem.KeyGenerator;
import votingSystem.KeyShare;
import votingSystem.PublicKey;
import votingSystem.Validator;
import votingSystem.Vote;
import ds.Server;
import exceptions.IncorrectVoteException;
import exceptions.InsufficientSharesException;
import exceptions.NoValidVotesException;

public class ElectionSystem {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

		Random rand = new SecureRandom();
		// int k, int L, int M, int l, int w, int t, int s,
		int L = 6;
		String[] voteNames = new String[L];
		for (int i = 0; i < L; i++) {
			voteNames[i] = "Number" + i;
		}
		int[] voteVal = new int[2];
		voteVal[0] = 2;
		voteVal[1] = 1;
		ElectionProperties ep = new ElectionProperties(256, L, 10000, 10, 5,
				80, 2, voteNames, 0, voteVal);

		// int k = 256;
		// int s = 1;
		//	
		// int t = 80;
		// int M = 100;
		// int l = 2;
		// int w = 1;

		KeyGenerator kg = new KeyGenerator(rand, ep.getK(), ep.getS());
		KeyShare[] ks = kg.generateKeys(ep.getl(), ep.getW());
		BigInteger vi[] = new BigInteger[ep.getl()];
		for (int i = 0; i < ks.length; i++) {
			vi[i] = ks[i].getVi();
		}

		PublicKey pk = new PublicKey(kg.getN(), kg.getG(), kg.getV(), vi, ep
				.getS());

		Validator val = new Validator(ep, pk);

		ElectionAuthority ea = new ElectionAuthority(pk, ep,null,false);

		Voter c1 = new Voter(0, ep, pk, rand, null);
		Voter c2 = new Voter(1, ep, pk, rand, null);
		// try {
		// c1 = new Client(1,ep,pk,rand);
		// c2 = new Client(2,ep,pk,rand);
		// } catch (IncorrectParameterException e) {

		// e.printStackTrace();
		// }
		/*
		 * Vote[] votes = new Vote[2]; try { votes[0] = c1.encryptVote(0);
		 * votes[1] = c2.encryptVote(3); } catch (IncorrectVoteException e1) { //
		 * TODO Auto-generated catch block e1.printStackTrace(); }
		 */
		// Server s1 = new Server(0, ks[0], ep, rand, pk);
		// System.out.println(s1.checkBinaryVote(v1));

		Server serverList[] = new Server[ep.getl()];
		for (int i = 0; i < ep.getl(); i++) {
			serverList[i] = new Server(ks[i].getId(), ks[i], ep, rand, pk);
		}
		long time1 = System.currentTimeMillis();
		Vote v = null;
		try {
			v = c1.encryptVote(3);
		} catch (IncorrectVoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		long time2 = System.currentTimeMillis();

		System.out.println("Time spent: " + (time2 - time1));
		System.out.println(val.checkProof(v));
		// DecryptedShare[] shareList = new DecryptedShare[ep.getl()];
		/*
		 * for(int i=0; i<ep.getl(); i++) try { shareList[i] =
		 * (serverList[i].shareDecrypt(votes)); } catch (NoValidVotesException
		 * e) { // TODO Auto-generated catch block e.printStackTrace(); }
		 * DecryptedShare temp = shareList[3]; shareList[3] = shareList[1];
		 * shareList[1] = temp;
		 */

		/*
		 * MultipleBinaryVotes[] vote= new MultipleBinaryVotes[2]; try { int[]
		 * votes1 = new int[2]; int[] votes2 = new int[2]; votes1[0] = 3;
		 * votes1[1] = 4; votes2[0] = 3; votes2[1] = 5; vote[0] =
		 * c1.encryptMultipleVoteBinary(votes1); vote[1] =
		 * c1.encryptMultipleVoteBinary(votes2);
		 *  } catch (IncorrectVoteException e) { e.printStackTrace(); }
		 */
		// DecryptedShare[] shareList= new DecryptedShare[ep.getl()];
		BinaryVote[] v_ = new BinaryVote[1];
		try {
			v_[0] = c1.encryptVoteBinary(3);
		} catch (IncorrectVoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		DecryptedShare[] shareList = new DecryptedShare[ep.getl()];
		for (int i = 0; i < ep.getl(); i++)
			try {
				shareList[i] = (serverList[i].shareDecrypt(v_));
			} catch (NoValidVotesException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		try {
			System.out.println(ea.shareCombine(shareList));
		} catch (InsufficientSharesException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		/*
		 * DecryptedShare temp = shareList[3]; shareList[3] = shareList[1];
		 * shareList[1] = temp;
		 */
		/*
		 * System.out.println("Check vote:
		 * "+val.checkBinaryVote(vote[0].getVotes()[0]));
		 * System.out.println(val.checkMultipleBinaryVote(vote[0]));
		 * 
		 * ArrayList a = new ArrayList(); for(int i=0; i<ep.getl(); i++){
		 * 
		 * try { a.add(serverList[i].shareDecrypt(vote));
		 *  } catch (NoValidVotesException e) { // TODO Auto-generated catch
		 * block e.printStackTrace(); } }
		 * 
		 * 
		 * /*try{ for(int i=0; i<1; i++)
		 * System.out.println(serverList[i].checkMultipleVote(vote[0])); }
		 * catch(NoValidVotesException e){ e.printStackTrace(); }
		 */
		/*
		 * BigInteger results = null;
		 * 
		 * 
		 */
		/*
		 * BigInteger results[] = new BigInteger[ep.getNoOfVotes()]; for(int
		 * i=0;i<ep.getNoOfVotes();i++){ DecryptedShare[] dsL = new
		 * DecryptedShare[ep.getl()]; for(int j=0;j<dsL.length;j++){ dsL[j] =
		 * ((DecryptedShare[])a.get(j))[i]; }
		 * 
		 * try {
		 * 
		 * results[i] = ea.shareCombine(dsL); System.out.println(results[i]); }
		 * catch (InsufficientSharesException e) { // TODO Auto-generated catch
		 * block e.printStackTrace(); } } Result r = new Result(); BigInteger[]
		 * test = r.getResultFromBinary(results, ep.getM(), ep.getL(),
		 * ep.getVoteWeights()); for(int i=0;i<test.length;i++)
		 * System.out.println(test[i]);
		 *  // new Result().getResultFromBinary(results, ep.getM(), ep.getL());
		 *  /* BigInteger p = BigInteger.probablePrime(k,rand); BigInteger q =
		 * BigInteger.probablePrime(k,rand); BigInteger phi =
		 * p.subtract(BigInteger.ONE).multiply(q.subtract(BigInteger.ONE));
		 * BigInteger n = p.multiply(q); BigInteger g =
		 * n.add(BigInteger.ONE).mod(n.pow(s));
		 * 
		 * //Create Server and Client; BigInteger r = new BigInteger
		 * (n.pow(s+1).bitLength (), rand); while ((r.compareTo (n.pow(s+1)) >=
		 * 0) || (r.compareTo (BigInteger.ZERO) == 0) ||
		 * (BigInteger.ONE.compareTo (r.gcd (n)) < 0)) r = new BigInteger
		 * (n.pow(s+1).bitLength (), rand);
		 * 
		 * 
		 * 
		 * 
		 * Encryption cl = new Encryption(k, 1000 ,s,n ,g); Decryption se = new
		 * Decryption(k, 1000, s, g, p,q);
		 * 
		 * System.out.println("s: "+s); System.out.println("n: "+n);
		 * System.out.println("p: "+p); System.out.println("q: "+q);
		 * System.out.println("g: "+g); System.out.println("phi: "+phi);
		 * 
		 * BigInteger voter1 = BigInteger.valueOf(1);
		 * System.out.println(voter1); BigInteger voter2 =
		 * BigInteger.valueOf(0); System.out.println(voter2); BigInteger voter3 =
		 * BigInteger.valueOf(1); System.out.println(voter3);
		 * 
		 * long time1 = System.currentTimeMillis(); BigInteger voter1ciph =
		 * cl.encryptGenPailler(r,voter1,s); long time2 =
		 * System.currentTimeMillis(); long timespent = time2-time1;
		 * System.out.println("encryption took: "+ timespent+ "ms."); time1 =
		 * System.currentTimeMillis(); BigInteger voter2ciph =
		 * cl.encryptGenPaillerSimple(r,voter2,s); time2 =
		 * System.currentTimeMillis(); timespent = time2-time1;
		 * System.out.println("encryption took: "+ timespent+ "ms."); BigInteger
		 * voter3ciph = cl.encryptGenPailler(r,voter3,s);
		 * 
		 * BigInteger sum =
		 * voter1ciph.multiply(voter2ciph).multiply(voter3ciph);
		 * 
		 * 
		 * 
		 * 
		 * 
		 * System.out.println("plain??: "+se.decryption(sum,s));
		 */

	}

}
