package remoteInterfaces;

import java.rmi.Remote;
import java.rmi.RemoteException;

import votingSystem.ElectionProperties;
import votingSystem.KeyShare;
import votingSystem.PublicKey;
/** The interface needed for using the remote object ElectionServer holding the PublicKey, the KeyShares and the ElectionProperties of the election
 * 
 * @author bent
 *
 */
public interface ElectionServer extends Remote {
	ElectionProperties getElectionProperties() throws RemoteException;

	PublicKey getPublicKey() throws RemoteException;
	/** Assigns an id to the decryption server, and returns the KeyShare
	 * 
	 */
	KeyShare getKeyShare() throws RemoteException;
	/** Gives an id to a voter
	 * 
	 * @return The id
	 */
	int getVoterId() throws RemoteException;

	int getNoOfVoters() throws RemoteException;

	int getNoOfDecryptionServers() throws RemoteException;

}
