package votingSystem;

import java.io.Serializable;
import java.math.BigInteger;
/** The data structure holding a BinaryVote and its proofs of correctness
 * 
 * @author bent
 *
 */
public class BinaryVote implements Serializable {

	private BigInteger[] encryption, fi, z1, z2, eMult, ed, edb, f;

	private BigInteger[][] e, z, a;

	private int id;

	public BinaryVote(BigInteger[] encryption, BigInteger[][] e,
			BigInteger[][] z, BigInteger[][] a, BigInteger[] fi,
			BigInteger[] z1, BigInteger[] z2, BigInteger[] eMult,
			BigInteger[] ed, BigInteger[] edb, BigInteger f[], int id) {
		this.encryption = encryption;
		this.fi = fi;
		this.z1 = z1;
		this.z2 = z2;
		this.eMult = eMult;
		this.ed = ed;
		this.edb = edb;
		this.f = f;
		this.e = e;
		this.z = z;
		this.a = a;
		this.id = id;

	}

	public int getId() {
		return id;
	}

	public BigInteger[][] getA() {
		return a;
	}

	public BigInteger[][] getE() {
		return e;
	}

	public BigInteger[] getEd() {
		return ed;
	}

	public BigInteger[] getEdb() {
		return edb;
	}

	public BigInteger[] getEMult() {
		return eMult;
	}

	public BigInteger[] getEncryption() {
		return encryption;
	}

	public BigInteger[] getF() {
		return f;
	}

	public BigInteger[] getFi() {
		return fi;
	}

	public BigInteger[][] getZ() {
		return z;
	}

	public BigInteger[] getZ1() {
		return z1;
	}

	public BigInteger[] getZ2() {
		return z2;
	}
}
