package votingSystem;

import java.io.Serializable;
import java.math.BigInteger;

/**
 * The class for holding the DecryptedShares from the decryption Servers
 * 
 * @author bent
 * 
 */
public class DecryptedShare implements Serializable {
	private BigInteger e, z, c, ci;

	private int tallyId;

	/*
	 * public DecryptedShare(BigInteger v_rand, BigInteger m_rand, BigInteger
	 * proof, BigInteger c, BigInteger ci, int tallyId){
	 * 
	 * this.a = v_rand; this.b = m_rand; this.e = proof; this.c = c; this.ci =
	 * ci; this.tallyId = tallyId; }
	 */
	/**
	 * Creates a DecryptedShare
	 * 
	 * @param e
	 *            The first part of the zero-knowledge proof of correctness. The
	 *            random challenge calculated using the hash-function.
	 * @param z
	 *            The other part of the zero-knowledge proof of correctness.
	 * @param c
	 *            The unaltered result of the election
	 * @param ci
	 *            The decrypted share from the server.
	 * @param id
	 *            The id of the Server doing the encryption.
	 */
	public DecryptedShare(BigInteger e, BigInteger z, BigInteger c,
			BigInteger ci, int id) {
		this.e = e;
		this.z = z;
		this.c = c;
		this.ci = ci;
		this.tallyId = id;
	}

	public int getTallyId() {
		return tallyId;
	}

	public BigInteger getC() {
		return c;
	}

	public BigInteger getCi() {
		return ci;
	}

	public BigInteger getE() {
		return e;
	}

	public BigInteger getZ() {
		return z;
	}

}
