package votingSystem;

import java.io.Serializable;
import java.math.BigInteger;
/** This class implements the data structure for holding a MultipleVote used in k-out-of-L elections as well as the proofs needed to prove
 *  correctness of the vote. More details of the proofs used can be found in the thesis.
 * 
 * @author Bent K. Onshus
 *
 */
public class MultipleVotes implements Serializable {
	private Vote[] votes;

	private BigInteger[][] ea, eb, ec, ed, edb, e, f, z1, z2;

	private int id;

	public MultipleVotes(Vote[] votes, BigInteger[][] ea, BigInteger[][] eb,
			BigInteger[][] ec, BigInteger[][] ed, BigInteger[][] edb,
			BigInteger[][] e, BigInteger[][] f, BigInteger[][] z1,
			BigInteger[][] z2, int id) {
		this.votes = votes;
		this.ea = ea;
		this.eb = eb;
		this.ec = ec;
		this.e = e;
		this.f = f;
		this.z1 = z1;
		this.z2 = z2;
		this.id = id;
		this.ed = ed;
		this.edb = edb;

	}

	public BigInteger[][] getE() {
		return e;
	}

	public BigInteger[][] getEa() {
		return ea;
	}

	public BigInteger[][] getEb() {
		return eb;
	}

	public BigInteger[][] getEc() {
		return ec;
	}

	public BigInteger[][] getF() {
		return f;
	}

	public Vote[] getVotes() {
		return votes;
	}

	public BigInteger[][] getZ1() {
		return z1;
	}

	public BigInteger[][] getZ2() {
		return z2;
	}

	public int getId() {
		return id;
	}

	public BigInteger[][] getEd() {
		return ed;
	}

	public BigInteger[][] getEdb() {
		return edb;
	}

}
