package votingSystem;

import java.math.BigInteger;

/**
 * Class for computing and displaying the Result of an election from the
 * plaintext value after decryption
 * 
 * @author Bent K. Onshus
 * 
 */
public class Result {

	private BigInteger results;

	private BigInteger voteValues[];

	private BigInteger voteResults[];

	/**
	 * Creates a new Result
	 * 
	 * 
	 */
	public Result() {

	}

	public BigInteger[] getResult(BigInteger results, BigInteger voteValues[]) {
		BigInteger temp = results;
		BigInteger[] voteResults = new BigInteger[voteValues.length];
		for (int i = 0; i < voteResults.length; i++) {
			temp = temp.divide(voteValues[0]);
			voteResults[i] = temp.mod(voteValues[0]);
			System.out.println("voteResults nr " + i + " : " + voteResults[i]);

		}
		return voteResults;
	}

	public BigInteger[] getResult(BigInteger results[],
			BigInteger voteValues[], int[] voteweights) {
		BigInteger[] voteResults = new BigInteger[voteValues.length];
		for (int j = 0; j < voteResults.length; j++)
			voteResults[j] = BigInteger.ZERO;

		for (int j = 0; j < results.length; j++) {

			BigInteger temp = results[j];
			for (int i = 0; i < voteResults.length; i++) {
				temp = temp.divide(voteValues[0]);
				voteResults[i] = voteResults[i].add(temp.mod(voteValues[0])
						.multiply(BigInteger.valueOf(voteweights[j])));
				System.out.println("voteResults nr " + i + " : "
						+ voteResults[i]);

			}

		}
		return voteResults;
	}

	public BigInteger[] getResultFromBinary(BigInteger[] results, int M, int L,
			int[] voteweights) {
		BigInteger voteResults[] = new BigInteger[L];
		for (int j = 0; j < L; j++)
			voteResults[j] = BigInteger.ZERO;

		for (int j = 0; j < results.length; j++) {
			BigInteger temp = results[j];
			for (int i = 0; i < L; i++) {
				voteResults[i] = voteResults[i].add((temp.mod(BigInteger
						.valueOf(M))).multiply(BigInteger
						.valueOf(voteweights[j])));
				temp = temp.divide(BigInteger.valueOf(M));
			}

		}
		return voteResults;

	}

	public BigInteger[] getResultFromBinary(BigInteger results, int M, int L) {
		BigInteger voteResults[] = new BigInteger[L];
		BigInteger temp = results;
		for (int i = 0; i < L; i++) {
			voteResults[i] = (temp.mod(BigInteger.valueOf(M)));
			temp = temp.divide(BigInteger.valueOf(M));
		}
		return voteResults;

	}

}
