package votingSystem;

import java.math.BigInteger;

/**
 * This class implements some useful functions for use with the cryptosystem
 * 
 * @author Bent
 * 
 */
public class Utility {

	/**
	 * Converts a BigInteger to an int
	 * 
	 * @param i
	 *            BigInteger to be converted
	 * @return An int
	 */
	public static int bigIntToInt(BigInteger i) {
		return i.intValue();
	}

	/**
	 * Converts an int to a BigInteger
	 * 
	 * @param i
	 *            int to be converted
	 * @return A BigInteger
	 */
	public static BigInteger intToBigInt(int i) {
		BigInteger temp = BigInteger.valueOf(i);
		return temp;
	}

	/**
	 * Converts a long to a BigInteger
	 * 
	 * @param i
	 *            The long to be converted
	 * @return A BigInteger
	 */
	public static BigInteger longToBigInt(long i) {
		BigInteger temp = BigInteger.valueOf(i);
		return temp;
	}

	/**
	 * Finds the least common multiplum of two BigIntegers
	 * 
	 * @param n1
	 * @param n2
	 * @return
	 */
	public static BigInteger lcm(BigInteger n1, BigInteger n2) {
		BigInteger gcd = n1.gcd(n2);

		if (gcd.compareTo(BigInteger.ZERO) == 0) {
			return BigInteger.ZERO;
		} else if (gcd.compareTo(BigInteger.ONE) == 0) {
			return n1.multiply(n2);
		} else {
			return n1.multiply(n2.divide(gcd));
		}
	}
/** Calculates n!
 * 
 * @param n
 * @return
 */
	public static long faculty(long n) {
		long prod = 1;
		for (long i = n; i > 0; i--) {
			prod = prod * i;
		}
		return prod;
	}

	public static double log2(int i) {
		return Math.log((double) i) / Math.log((double) 2);
	}

}
