package votingSystem;

import java.io.Serializable;
import java.math.BigInteger;

/**
 * Class for holding a Vote and its zero-knowledge proof of correctness
 * 
 * @author bent
 * 
 */
public class Vote implements Serializable {

	private int id;

	private BigInteger vote;

	private BigInteger[] a;

	private BigInteger challenge;

	private BigInteger[] z;

	private BigInteger[] e;

	/**
	 * Creates a new vote
	 * 
	 * @param _vote
	 *            The encrypted vote
	 * @param _a
	 *            Part of the zero-knowledge proof
	 * @param _challenge
	 *            The challenge in the zero-knowledge proof
	 * @param _z
	 *            Part of the zero-knowledge proof
	 * @param _e
	 * @param id
	 *            The voter's id
	 */
	public Vote(BigInteger _vote, BigInteger[] _a, BigInteger _challenge,
			BigInteger[] _z, BigInteger[] _e, int id) {
		vote = _vote;
		a = _a;
		challenge = _challenge;
		z = _z;
		e = _e;
		this.id = id;
	}

	public String toString() {
		String str = new String();

		return str;
	}

	public BigInteger[] getA() {
		return a;
	}

	public BigInteger getChallenge() {
		return challenge;
	}

	public BigInteger[] getE() {
		return e;
	}

	public BigInteger getVote() {
		return vote;
	}

	public BigInteger[] getZ() {
		return z;
	}

	public int getId() {
		return id;
	}

}
